local _, addon = ...
local mapID
addon['pins'] = addon['pins'] or {}
local usedMaps = {}
local function mapTrans(x,y,btn)
	local fr = WORLDMAP_SETTINGS['size']
	local width = WorldMapButton:GetWidth() * fr
	local height = WorldMapButton:GetHeight() * fr
	local pw = width/100
	local ph = height/100
	local nx = x * pw
	local ny = y * ph
	btn:SetPoint("TOPLEFT", WorldMapButton, "TOPLEFT",nx - (btn:GetWidth()/2),-ny + (btn:GetHeight()/2))
end
addon['updatePin'] = function(name,mapID)
	local btn = addon['pins'][name][#addon['pins'][name]]
	if(addon['pins'][name][3]==mapID) then
		btn:SetSize(16,16)
		btn:SetFrameLevel(WorldMapButton:GetFrameLevel()+2)
		btn['btnName'] = name
		mapTrans(tonumber(addon['pins'][name][1]),tonumber(addon['pins'][name][2]),btn)
		btn:Show()
	else
		btn:Hide()
	end
end
local function TTS(self)
	local btn = addon['pins'][self['btnName']]
	GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
	GameTooltip:AddLine(btn[4])
	GameTooltip:AddLine(btn[1].."/"..btn[2])
	GameTooltip:Show()
end
local function TTH()
	GameTooltip:Hide()
end
addon['addPin'] = function(name, ...) -- name,x,y,mapId,label,icon
	local btn = CreateFrame("Frame",name,WorldMapFrame)
	addon['pins'][name] = {...}
	btn:SetScript("OnEnter", TTS)
	btn:SetScript("OnLeave", TTH)
	local tex = btn:CreateTexture(nil, "OVERLAY")
	tex:SetAllPoints()
	tex:SetTexture(addon['pins'][name][5])
	addon['pins'][name][#addon['pins'][name]+1] = btn
	usedMaps[addon['pins'][name][3]] = true
end
addon['removePin'] = function(name)
	addon['pins'][name][#addon['pins'][name]]:Hide()
	addon['pins'][name][#addon['pins'][name]]:UnregisterAllEvents()
	addon['pins'][name] = nil
end
addon['getPin'] = function(name, ...)
	if(addon['pins'][name]) then
		return addon['pins'][name]
	else
		addon['addPin'](name, ...)
	end
end
local f = CreateFrame("Frame",nil,WorldMapButton)
f.lu = 0
f.lt = 4
f:RegisterEvent("WORLD_MAP_UPDATE")
local function evnt(self)
	mapID = GetCurrentMapAreaID()
	if(usedMaps[mapID]) then
		for name, pin in pairs(addon['pins']) do
			addon['updatePin'](name, mapID)
		end
	end
end
addon['RegisterEventThrottle'](f ,childName, "WORLD_MAP_UPDATE", 2, evnt)
f:SetScript("OnUpdate", function(self, el)
	self.lu = self.lu - el
	if(self.lu < 0) then
		self.lu = self.lt
		if(self.fr ~= WORLDMAP_SETTINGS['size']) then
			self.fr = WORLDMAP_SETTINGS['size']
			evnt(self)
		end
	end
end)
